/*
 * This file was generated - do not edit it directly !!
 * Generated by AuDAO tool, a product of Spolecne s.r.o.
 * For more information please visit http://www.spoledge.com
 */
package com.spoledge.facicredit.db.dao;

import java.sql.Connection;


/**
 * This is the main class for obtaining DAO objects.
 * It looks for the system property called "com.spoledge.facicredit.db.dao.DB_TYPE"
 * and its value is used as the DAO implementation subpackage name.
 * The default value is "oracle".
 * The name of the Factory class is assumed to be "DaoFactoryImpl"
 * and it must have the default constructor defined.
 *
 * @author generated
 */
public class DaoFactory {

    private static Factory factory;

    static {
        String pkgDao = DaoFactory.class.getPackage().getName();
        String pkgImpl = pkgDao + '.' + System.getProperty( pkgDao + ".DB_TYPE", "oracle" );
        try {
            Class<?> aclazz = Class.forName( pkgImpl + ".DaoFactoryImpl" );
            Class<? extends Factory> clazz = aclazz.asSubclass( Factory.class );
            factory = clazz.newInstance();
        }
        catch (Exception e) {
            throw new Error("A problem occurred when resolving DAO factory class", e);
        }
    }


    ////////////////////////////////////////////////////////////////////////////
    // Static methods
    ////////////////////////////////////////////////////////////////////////////

    public static EntityDao createEntityDao( Connection conn ) {
        return factory.createEntityDao( conn );
    }

    public static LogOperationDao createLogOperationDao( Connection conn ) {
        return factory.createLogOperationDao( conn );
    }

    public static LogHistoryDao createLogHistoryDao( Connection conn ) {
        return factory.createLogHistoryDao( conn );
    }

    public static UserCommentDao createUserCommentDao( Connection conn ) {
        return factory.createUserCommentDao( conn );
    }


    ////////////////////////////////////////////////////////////////////////////
    // Inner classes
    ////////////////////////////////////////////////////////////////////////////

    public static abstract class Factory {

        public abstract EntityDao createEntityDao( Connection conn );

        public abstract LogOperationDao createLogOperationDao( Connection conn );

        public abstract LogHistoryDao createLogHistoryDao( Connection conn );

        public abstract UserCommentDao createUserCommentDao( Connection conn );

    }
}
