/*
 * This file was generated - do not edit it directly !!
 * Generated by AuDAO tool, a product of Spolecne s.r.o.
 * For more information please visit http://www.spoledge.com
 */
package com.spoledge.facicredit.db.dao.oracle;


import java.sql.Connection;
import java.sql.Date;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.sql.Types;

import java.util.ArrayList;
import java.util.HashMap;

import com.spoledge.audao.db.dao.AbstractDaoImpl;
import com.spoledge.audao.db.dao.DBException;
import com.spoledge.audao.db.dao.DaoException;


import com.spoledge.facicredit.db.dao.LogHistoryDao;
import com.spoledge.facicredit.db.dto.LogHistory;
import com.spoledge.facicredit.db.dto.Entity;
import com.spoledge.facicredit.db.dto.LogOperation;


/**
 * This is the DAO imlementation class.
 *
 * @author generated
 */
public class LogHistoryDaoImpl extends AbstractDaoImpl<LogHistory> implements LogHistoryDao {

    private static final String TABLE_NAME = "log_history";

    protected static final String SELECT_COLUMNS = "log_id, created_date, user_id, entity_id, record_id, log_oper_id, user_comment_id";

    protected static final String PK_CONDITION = "log_id=?";

    private static final String SQL_INSERT = "INSERT INTO log_history (log_id, created_date, user_id, entity_id, record_id, log_oper_id, user_comment_id) VALUES (?, ?, ?, ?, ?, ?, ?)";
    private static final HashMap<Integer, Entity.EntityId> _Entity_EntityIds = new HashMap<Integer, Entity.EntityId>();

    static {
        _Entity_EntityIds.put( Entity.EntityId.SEGMENT.getId(), Entity.EntityId.SEGMENT);
        _Entity_EntityIds.put( Entity.EntityId.SEGMENT_RATING.getId(), Entity.EntityId.SEGMENT_RATING);
        _Entity_EntityIds.put( Entity.EntityId.SEGMENT_CONFIDENCE.getId(), Entity.EntityId.SEGMENT_CONFIDENCE);
        _Entity_EntityIds.put( Entity.EntityId.COMPANY_ACTIVITY_TYPE.getId(), Entity.EntityId.COMPANY_ACTIVITY_TYPE);
        _Entity_EntityIds.put( Entity.EntityId.PARTY.getId(), Entity.EntityId.PARTY);
        _Entity_EntityIds.put( Entity.EntityId.PARTY_ICO.getId(), Entity.EntityId.PARTY_ICO);
        _Entity_EntityIds.put( Entity.EntityId.PARTY_NAME.getId(), Entity.EntityId.PARTY_NAME);
        _Entity_EntityIds.put( Entity.EntityId.PARTY_ADDRESS.getId(), Entity.EntityId.PARTY_ADDRESS);
        _Entity_EntityIds.put( Entity.EntityId.PARTY_PHONE.getId(), Entity.EntityId.PARTY_PHONE);
        _Entity_EntityIds.put( Entity.EntityId.PAYMENT_RATING.getId(), Entity.EntityId.PAYMENT_RATING);
        _Entity_EntityIds.put( Entity.EntityId.FINANCIAL_STATE.getId(), Entity.EntityId.FINANCIAL_STATE);
        _Entity_EntityIds.put( Entity.EntityId.PARTY_RATING.getId(), Entity.EntityId.PARTY_RATING);
        _Entity_EntityIds.put( Entity.EntityId.USER_COMMENT.getId(), Entity.EntityId.USER_COMMENT);
        _Entity_EntityIds.put( Entity.EntityId.BATCH.getId(), Entity.EntityId.BATCH);
        _Entity_EntityIds.put( Entity.EntityId.LOG_HISTORY.getId(), Entity.EntityId.LOG_HISTORY);
        _Entity_EntityIds.put( Entity.EntityId.USER.getId(), Entity.EntityId.USER);
        _Entity_EntityIds.put( Entity.EntityId.ROLE.getId(), Entity.EntityId.ROLE);
        _Entity_EntityIds.put( Entity.EntityId.USER_ROLE.getId(), Entity.EntityId.USER_ROLE);
        _Entity_EntityIds.put( Entity.EntityId.APPSEC_MODULE.getId(), Entity.EntityId.APPSEC_MODULE);
        _Entity_EntityIds.put( Entity.EntityId.APPSEC_ACTION.getId(), Entity.EntityId.APPSEC_ACTION);
        _Entity_EntityIds.put( Entity.EntityId.APPSEC_ACCESS.getId(), Entity.EntityId.APPSEC_ACCESS);
    }
    private static final LogOperation.LogOperId[] _LogOperation_LogOperIds = { null, LogOperation.LogOperId.CREATE, LogOperation.LogOperId.UPDATE, LogOperation.LogOperId.DELETE, LogOperation.LogOperId.COMMENT };

    public LogHistoryDaoImpl( Connection conn ) {
        super( conn );
    }

    /**
     * Returns the expression used for ORDER BY clause.
     * @return the order expression for the given column, for example:
     *           company_name (MySQL)
     *           NLSSORT(company_name, 'NLS_SORT=generic_m') (Oracle)
     */
    public String getOrderExpr( LogHistory.Column col ) {
        return col.columnName();
    }

    /**
     * Finds a record identified by its primary key.
     * @return the record found or null
     */
    public LogHistory findByPrimaryKey( int logId ) {
        return findOne( PK_CONDITION, logId);
    }

    /**
     * Counts records.
     */
    public int countDynamic( String cond, Object... params ) {
        return count( cond, params);
    }

    /**
     * Finds records ordered by created_date.
     */
    public LogHistory[] findDynamic( String cond, int offset, int count, Object... params ) {
        return findManyArray( cond + " ORDER BY created_date", offset, count, params);
    }

    /**
     * Inserts a new record.
     * @return the generated primary key - logId
     */
    public int insert( LogHistory dto ) throws DaoException {
        PreparedStatement stmt = null;
        debugSql( SQL_INSERT, dto );

        try {
            stmt = conn.prepareStatement( SQL_INSERT );
            dto.setLogId( selectInt( "SELECT seq_log_history.nextval FROM DUAL" ));

            if ( dto.getLogId() == null ) {
                throw new DaoException("Value of column 'log_id' cannot be null");
            }
            stmt.setInt( 1, dto.getLogId() );

            if ( dto.getCreatedDate() == null ) {
                dto.setCreatedDate( new Timestamp( System.currentTimeMillis()));
            }
            stmt.setTimestamp( 2, dto.getCreatedDate() );

            if ( dto.getUserId() == null ) {
                throw new DaoException("Value of column 'user_id' cannot be null");
            }
            stmt.setInt( 3, dto.getUserId() );

            if ( dto.getEntityId() == null ) {
                throw new DaoException("Value of column 'entity_id' cannot be null");
            }
            stmt.setInt( 4, dto.getEntityId().getId() );

            if ( dto.getRecordId() == null ) {
                throw new DaoException("Value of column 'record_id' cannot be null");
            }
            stmt.setInt( 5, dto.getRecordId() );

            if ( dto.getLogOperId() == null ) {
                throw new DaoException("Value of column 'log_oper_id' cannot be null");
            }
            stmt.setInt( 6, dto.getLogOperId().ordinal() + 1 );

            if ( dto.getUserCommentId() == null ) {
                stmt.setNull( 7, Types.INTEGER );
            }
            else {
                stmt.setInt( 7, dto.getUserCommentId() );
            }

            int n = stmt.executeUpdate();

            return dto.getLogId();
        }
        catch (SQLException e) {
            errorSql( e, SQL_INSERT, dto );
            handleException( e );
            throw new DBException( e );
        }
        finally {
            if (stmt != null) try { stmt.close(); } catch (SQLException e) {}
        }
    }

    /**
     * Updates column user_comment_id of one record found by primary key.
     * @return true iff the record was really updated (=found)
     */
    public boolean updateUserCommentId( int logId, Integer userCommentId ) throws DaoException {
        return updateOne( ( userCommentId != null ? "user_comment_id=?" : "user_comment_id=NULL"), PK_CONDITION, userCommentId, logId);
    }

    /**
     * Returns the table name.
     */
    public String getTableName() {
        return TABLE_NAME;
    }

    protected String getSelectColumns() {
        return SELECT_COLUMNS;
    }

    protected LogHistory fetch( ResultSet rs ) throws SQLException {
        LogHistory dto = new LogHistory();
        dto.setLogId( rs.getInt( 1 ));
        dto.setCreatedDate( rs.getTimestamp( 2 ));
        dto.setUserId( rs.getInt( 3 ));
        dto.setEntityId( _Entity_EntityIds.get( rs.getInt( 4 )));
        dto.setRecordId( rs.getInt( 5 ));
        dto.setLogOperId( _LogOperation_LogOperIds[ rs.getInt( 6 ) ]);
        dto.setUserCommentId( rs.getInt( 7 ));

        if ( rs.wasNull()) {
            dto.setUserCommentId( null );
        }


        return dto;
    }

    protected LogHistory[] toArray(ArrayList<LogHistory> list ) {
        LogHistory[] ret = new LogHistory[ list.size() ];
        return list.toArray( ret );
    }

}
