/*
 * This file was generated - do not edit it directly !!
 * Generated by AuDAO tool, a product of Spolecne s.r.o.
 * For more information please visit http://www.spoledge.com
 */
package com.spoledge.facicredit.db.dao.oracle;


import java.sql.Connection;
import java.sql.Date;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.sql.Types;

import java.util.ArrayList;
import java.util.HashMap;

import com.spoledge.audao.db.dao.AbstractDaoImpl;
import com.spoledge.audao.db.dao.DBException;
import com.spoledge.audao.db.dao.DaoException;


import com.spoledge.facicredit.db.dao.UserCommentDao;
import com.spoledge.facicredit.db.dto.UserComment;
import com.spoledge.facicredit.db.dto.Entity;


/**
 * This is the DAO imlementation class.
 *
 * @author generated
 */
public class UserCommentDaoImpl extends AbstractDaoImpl<UserComment> implements UserCommentDao {

    private static final String TABLE_NAME = "user_comments";

    protected static final String SELECT_COLUMNS = "user_comment_id, entity_id, record_id, comment_subtype, user_comment";

    protected static final String PK_CONDITION = "user_comment_id=?";

    private static final String SQL_INSERT = "INSERT INTO user_comments (user_comment_id, entity_id, record_id, comment_subtype, user_comment) VALUES (?, ?, ?, ?, ?)";
    private static final HashMap<Integer, Entity.EntityId> _Entity_EntityIds = new HashMap<Integer, Entity.EntityId>();

    static {
        _Entity_EntityIds.put( Entity.EntityId.SEGMENT.getId(), Entity.EntityId.SEGMENT);
        _Entity_EntityIds.put( Entity.EntityId.SEGMENT_RATING.getId(), Entity.EntityId.SEGMENT_RATING);
        _Entity_EntityIds.put( Entity.EntityId.SEGMENT_CONFIDENCE.getId(), Entity.EntityId.SEGMENT_CONFIDENCE);
        _Entity_EntityIds.put( Entity.EntityId.COMPANY_ACTIVITY_TYPE.getId(), Entity.EntityId.COMPANY_ACTIVITY_TYPE);
        _Entity_EntityIds.put( Entity.EntityId.PARTY.getId(), Entity.EntityId.PARTY);
        _Entity_EntityIds.put( Entity.EntityId.PARTY_ICO.getId(), Entity.EntityId.PARTY_ICO);
        _Entity_EntityIds.put( Entity.EntityId.PARTY_NAME.getId(), Entity.EntityId.PARTY_NAME);
        _Entity_EntityIds.put( Entity.EntityId.PARTY_ADDRESS.getId(), Entity.EntityId.PARTY_ADDRESS);
        _Entity_EntityIds.put( Entity.EntityId.PARTY_PHONE.getId(), Entity.EntityId.PARTY_PHONE);
        _Entity_EntityIds.put( Entity.EntityId.PAYMENT_RATING.getId(), Entity.EntityId.PAYMENT_RATING);
        _Entity_EntityIds.put( Entity.EntityId.FINANCIAL_STATE.getId(), Entity.EntityId.FINANCIAL_STATE);
        _Entity_EntityIds.put( Entity.EntityId.PARTY_RATING.getId(), Entity.EntityId.PARTY_RATING);
        _Entity_EntityIds.put( Entity.EntityId.USER_COMMENT.getId(), Entity.EntityId.USER_COMMENT);
        _Entity_EntityIds.put( Entity.EntityId.BATCH.getId(), Entity.EntityId.BATCH);
        _Entity_EntityIds.put( Entity.EntityId.LOG_HISTORY.getId(), Entity.EntityId.LOG_HISTORY);
        _Entity_EntityIds.put( Entity.EntityId.USER.getId(), Entity.EntityId.USER);
        _Entity_EntityIds.put( Entity.EntityId.ROLE.getId(), Entity.EntityId.ROLE);
        _Entity_EntityIds.put( Entity.EntityId.USER_ROLE.getId(), Entity.EntityId.USER_ROLE);
        _Entity_EntityIds.put( Entity.EntityId.APPSEC_MODULE.getId(), Entity.EntityId.APPSEC_MODULE);
        _Entity_EntityIds.put( Entity.EntityId.APPSEC_ACTION.getId(), Entity.EntityId.APPSEC_ACTION);
        _Entity_EntityIds.put( Entity.EntityId.APPSEC_ACCESS.getId(), Entity.EntityId.APPSEC_ACCESS);
    }

    public UserCommentDaoImpl( Connection conn ) {
        super( conn );
    }

    /**
     * Returns the expression used for ORDER BY clause.
     * @return the order expression for the given column, for example:
     *           company_name (MySQL)
     *           NLSSORT(company_name, 'NLS_SORT=generic_m') (Oracle)
     */
    public String getOrderExpr( UserComment.Column col ) {
        return col.columnName();
    }

    /**
     * Finds a record identified by its primary key.
     * @return the record found or null
     */
    public UserComment findByPrimaryKey( int userCommentId ) {
        return findOne( PK_CONDITION, userCommentId);
    }

    /**
     * Finds records.
     */
    public UserComment[] findByEntityIdRecordId( Entity.EntityId entityId, Integer recordId ) {
        return findManyArray( "entity_id=? and record_id" + (recordId != null ? "=?" : " IS NULL"), 0, -1, entityId.getId(), recordId);
    }

    /**
     * Finds records.
     */
    public UserComment[] findByEntityId( Entity.EntityId entityId ) {
        return findManyArray( "entity_id=?", 0, -1, entityId.getId());
    }

    /**
     * Inserts a new record.
     * @return the generated primary key - userCommentId
     */
    public int insert( UserComment dto ) throws DaoException {
        PreparedStatement stmt = null;
        debugSql( SQL_INSERT, dto );

        try {
            stmt = conn.prepareStatement( SQL_INSERT );
            dto.setUserCommentId( selectInt( "SELECT seq_user_comments.nextval FROM DUAL" ));

            if ( dto.getUserCommentId() == null ) {
                throw new DaoException("Value of column 'user_comment_id' cannot be null");
            }
            stmt.setInt( 1, dto.getUserCommentId() );

            if ( dto.getEntityId() == null ) {
                throw new DaoException("Value of column 'entity_id' cannot be null");
            }
            stmt.setInt( 2, dto.getEntityId().getId() );

            if ( dto.getRecordId() == null ) {
                stmt.setNull( 3, Types.INTEGER );
            }
            else {
                stmt.setInt( 3, dto.getRecordId() );
            }

            if ( dto.getCommentSubtype() == null ) {
                stmt.setNull( 4, Types.INTEGER );
            }
            else {
                stmt.setInt( 4, dto.getCommentSubtype() );
            }

            if ( dto.getUserComment() != null ) {
                checkMaxLength( "user_comment", dto.getUserComment(), 2000 );
            }
            stmt.setString( 5, dto.getUserComment() );

            int n = stmt.executeUpdate();

            return dto.getUserCommentId();
        }
        catch (SQLException e) {
            errorSql( e, SQL_INSERT, dto );
            handleException( e );
            throw new DBException( e );
        }
        finally {
            if (stmt != null) try { stmt.close(); } catch (SQLException e) {}
        }
    }

    /**
     * Updates column user_comment of one record found by primary key.
     * @return true iff the record was really updated (=found)
     */
    public boolean updateUserComment( int userCommentId, String userComment ) throws DaoException {
        if ( userComment != null ) {
            checkMaxLength( "user_comment", userComment, 2000 );
        }

        return updateOne( ( userComment != null ? "user_comment=?" : "user_comment=NULL"), PK_CONDITION, userComment, userCommentId);
    }

    /**
     * Returns the table name.
     */
    public String getTableName() {
        return TABLE_NAME;
    }

    protected String getSelectColumns() {
        return SELECT_COLUMNS;
    }

    protected UserComment fetch( ResultSet rs ) throws SQLException {
        UserComment dto = new UserComment();
        dto.setUserCommentId( rs.getInt( 1 ));
        dto.setEntityId( _Entity_EntityIds.get( rs.getInt( 2 )));
        dto.setRecordId( rs.getInt( 3 ));

        if ( rs.wasNull()) {
            dto.setRecordId( null );
        }

        dto.setCommentSubtype( rs.getInt( 4 ));

        if ( rs.wasNull()) {
            dto.setCommentSubtype( null );
        }

        dto.setUserComment( rs.getString( 5 ));

        return dto;
    }

    protected UserComment[] toArray(ArrayList<UserComment> list ) {
        UserComment[] ret = new UserComment[ list.size() ];
        return list.toArray( ret );
    }

}
